﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private lvFiles As ListView
	Private BtnCopy As Button	'TEST 19/11/2019
	
	Dim smbclient As SMBClient	'TEST 19/11/2019

End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("LayoutFiles")

End Sub
Sub Loadfiles(filelist As List)
	lvFiles.Clear
	If filelist.IsInitialized And filelist.Size > 0 Then
		For i=0 To filelist.Size-1
			Dim f As SMBFile = filelist.Get(i)
			'FILE CanonicalPath = smb://192.168.192.168/GeoTIFs/koeln/ (0)
			Log($"FILE CanonicalPath = ${f.CanonicalPath} (${f.length})"$)
			lvFiles.AddTwoLines2(f.Name, f.CanonicalPath,f)
		Next
	End If
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

'TEST 19/11/2019 Aggiungo la possibilità di cancellare i file nella cartella di rete
Sub lvFiles_ItemLongClick (Position As Int, Value As Object)
	If Value <> Null Then
		Log(Position & " - " & Value)
		Msgbox2Async("Confermare cancellazione del file: " & Value, "Warning", "OK", "Cancel", "", Null, False)
		Wait For Msgbox_Result (Result As Int)
		If Result = DialogResponse.POSITIVE Then
			smbclient.Initialize("SMBClient",Main.credentials.Domain,Main.credentials.Username,Main.credentials.Password,Main.credentials.Share)
			smbclient.delete(Value)
			
			CallSub2(Starter,"SMBInit",Main.credentials)

		End If
		
	End If
	
End Sub

'TEST 19/11/2019 esempio di lettura dei file presenti sulla cartella di rete'
Sub lvFiles_ItemClick (Position As Int, Value As Object)
	Try
		
		If Value <> Null Then
			Log(Position & " - " & Value)
			File.Delete(File.DirInternal, "temp.txt")
			
			smbclient.Initialize("SMBClient",Main.credentials.Domain,Main.credentials.Username,Main.credentials.Password,Main.credentials.Share)
			smbclient.Copy(Value, File.DirInternal, "temp.txt")
			
			wait for SMBClient_CopyResult(success As Boolean, path As String, filename As String)
			If success Then
				File.OpenInput(File.DirInternal, "temp.txt")
				Dim testo As String = File.ReadString(File.DirInternal, "temp.txt")
				MsgboxAsync(testo, Value)
			Else
				MsgboxAsync("Copy non riuscito, riprovare.", "Warning")
			End If
		End If
	
	Catch
		Log(LastException)
	End Try


End Sub


'TEST 19/11/2019	Copia un file dalla app alla cartella di rete
' ho preso spunto da questo esempio: https://www.b4x.com/android/forum/threads/jcifs-ng-smb-client.110413/#post-690487
Sub BtnCopy_Click	
	'smbclient.GetResourcefromUrl("smb://192.168.192.168/GeoTIFs/") ' getting a reference to a resource where you want to create a new file.
	smbclient.Initialize("SMBClient",Main.credentials.Domain,Main.credentials.Username,Main.credentials.Password,Main.credentials.Share)
	smbclient.GetResourcefromUrl(Main.credentials.Share) ' getting a reference to a resource where you want to create a new file.
	wait for SMBClient_Resource(success As Boolean, smbobjres As Object,smbobj As Object, info As String)
	Log($"writetest-SMBClient_Resource(${success},${info},${smbobjres},${smbobj})"$)
	If smbobjres <> Null And smbobj <> Null And info = "OK" Then
		Dim smbResource As SMBResource = smbobjres ' the resource object pointing to smb://192.168.192.168/GeoTIFs/
		Dim sfile As SMBFile = smbobj
		
		Dim now As Long = DateTime.Now
		DateTime.DateFormat = "yyyy/MM/dd"
		Dim date As String = DateTime.Date (now)
		Dim time As String = DateTime.Time (now)
		
		File.WriteString(File.DirInternal, "1.txt", "Date and Time: " & date & " - " & time)' write what you want to write to a file in File.Dirinternal.
		
		date = date.Replace("/", "")
		time = time.Replace(":", "")
		smbclient.Copy2(File.DirInternal,"1.txt",sfile, date & "-" & time & ".txt") ' Copy the file to the SMBFile reference (also pointing to smb://192.168.192.168/GeoTIFs/). The content of File.Dirinternal\1.txt is written to textfile.txt in the resource smb://192.168.192.168/GeoTIFs/
		
		' in fact it is creating the resource smb://192.168.192.168/GeoTIFs/textfile.txt
		
		CallSub2(Starter,"SMBInit",Main.credentials)

	End If
End Sub

